/**
 * Converts an object into an array of key, value arrays. Only the object's
 * own properties are used.
 *
 * @func
 * @category Object
 * @sig {String: *} -> [[String,*]]
 * @param {Object} obj The object to extract from
 * @return {Array} An array of key, value arrays from the object's own properties.
 * @example
 *
 *      R.toPairs({a: 1, b: 2, c: 3}); //=> [['a', 1], ['b', 2], ['c', 3]]
 */
export function toPairs(obj){
  return Object.entries(obj)
}
